#property copyright "MaxZ"
#property link      "zagizop@yandex.ru"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Gold
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_color4 Blue
#property indicator_color5 Red
#property indicator_color6 Blue
#property indicator_color7 Red

extern int    MAPeriod     = 45;
extern int    ATRPeriod    = 45;
extern int    Shift        = 0;
extern double Deviations   = 3.0;

double MovingBuffer[];
double UpperBuffer1[];
double LowerBuffer1[];
double UpperBuffer2[];
double LowerBuffer2[];
double UpperBuffer3[];
double LowerBuffer3[];

int init()
{
   SetIndexStyle (0, DRAW_LINE);
   SetIndexBuffer(0, MovingBuffer);
   SetIndexStyle (1, DRAW_LINE);
   SetIndexBuffer(1, UpperBuffer1);
   SetIndexStyle (2, DRAW_LINE);
   SetIndexBuffer(2, LowerBuffer1);
   SetIndexStyle (3, DRAW_LINE);
   SetIndexBuffer(3, UpperBuffer2);
   SetIndexStyle (4, DRAW_LINE);
   SetIndexBuffer(4, LowerBuffer2);
   SetIndexStyle (5, DRAW_LINE);
   SetIndexBuffer(5, UpperBuffer3);
   SetIndexStyle (6, DRAW_LINE);
   SetIndexBuffer(6, LowerBuffer3);
   
   SetIndexDrawBegin(0, MAPeriod+Shift);
   SetIndexDrawBegin(1, MAPeriod+Shift);
   SetIndexDrawBegin(2, MAPeriod+Shift);
   SetIndexDrawBegin(3, MAPeriod+Shift);
   SetIndexDrawBegin(4, MAPeriod+Shift);
   SetIndexDrawBegin(5, MAPeriod+Shift);
   SetIndexDrawBegin(6, MAPeriod+Shift);
}

int start()
{
   int    i, k, counted_bars = IndicatorCounted();
   double Dev;
   
   if (Bars <= MAPeriod) return(0);
   
   if (counted_bars < 1)
      for(i = 1; i <= MAPeriod; i++)
      {
         MovingBuffer[Bars-i] = EMPTY_VALUE;
         UpperBuffer1[Bars-i] = EMPTY_VALUE;
         LowerBuffer1[Bars-i] = EMPTY_VALUE;
         UpperBuffer2[Bars-i] = EMPTY_VALUE;
         LowerBuffer2[Bars-i] = EMPTY_VALUE;
         UpperBuffer3[Bars-i] = EMPTY_VALUE;
         LowerBuffer3[Bars-i] = EMPTY_VALUE;
        }
   
   int limit = Bars-counted_bars;
   if (counted_bars > 0) limit++;
   for (i = 0; i < limit; i++)
      MovingBuffer[i] = iMA(NULL, 0, MAPeriod, Shift, MODE_SMA, PRICE_CLOSE, i);
   
   i = Bars - MAPeriod+1;
   if (counted_bars > MAPeriod-1)
      i = Bars-counted_bars-1;
   while (i >= 0)
   {
      Dev = Deviations*iATR(NULL, 0, ATRPeriod, i);
      UpperBuffer1[i] = MovingBuffer[i]+Dev;
      LowerBuffer1[i] = MovingBuffer[i]-Dev;
      UpperBuffer2[i] = UpperBuffer1[i]+Dev;
      LowerBuffer2[i] = LowerBuffer1[i]-Dev;
      UpperBuffer3[i] = UpperBuffer2[i]+Dev;
      LowerBuffer3[i] = LowerBuffer2[i]-Dev;
      i--;
   }
}